// IDAPrint.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "IDAPrint.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


void IDA_OnBeginPrinting(CDC *pDC, CPrintInfo* pInfo)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	FORMATETC fmtetc = { CF_DIB, 0, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
				STGMEDIUM stgmed;
				
				IDataObject  *pDataObject=NULL;
				
				if(OleGetClipboard(&pDataObject)!=S_OK)
					return;
				
				
				if(pDataObject->GetData(&fmtetc, &stgmed) == S_OK)
				{
					
					LPBITMAPINFO     lpBI ;
					void*            pDIBBits;
					lpBI= (LPBITMAPINFO)GlobalLock(stgmed.hGlobal);
					
					pDIBBits = (void*)(lpBI + 1); 
					
					// Get page size
					SIZE szPage;
					szPage.cx  =GetDeviceCaps(pDC->GetSafeHdc(),HORZRES);
					szPage.cy = GetDeviceCaps(pDC->GetSafeHdc(),VERTRES);

					
					float fBmiRatio = float(lpBI->bmiHeader.biHeight) / lpBI->bmiHeader.biWidth;
					SIZE szImageOnPage;  
					if (szPage.cx > szPage.cy)	 // Landscape page
					{
						if(fBmiRatio<1)	  // Landscape image
						{
							szImageOnPage.cx = szPage.cx;
							szImageOnPage.cy = long(fBmiRatio * szPage.cy);
						}
						else			  // Portrait image
						{
							szImageOnPage.cx = long(szPage.cy/fBmiRatio);
							szImageOnPage.cy = szPage.cy;
						}
					}
					else		    // Portrait page
					{
						if(fBmiRatio<1)	  // Landscape image
						{
							szImageOnPage.cx = szPage.cx;
							szImageOnPage.cy = long(fBmiRatio * szPage.cx);
						}
						else			  // Portrait image
						{
							szImageOnPage.cx = long(szPage.cx/fBmiRatio);
							szImageOnPage.cy = szPage.cy;
						}
					}
					
					CSize szOffset((szPage.cx - szImageOnPage.cx) / 2, (szPage.cy - szImageOnPage.cy) / 2);

					::StretchDIBits(pDC->GetSafeHdc(),
						szOffset.cx, szOffset.cy, 
						szImageOnPage.cx, szImageOnPage.cy,
						0, 0, lpBI->bmiHeader.biWidth, 
						lpBI->bmiHeader.biHeight,
						pDIBBits, lpBI, DIB_RGB_COLORS, SRCCOPY);
					
					
					
					GlobalUnlock(stgmed.hGlobal);
					ReleaseStgMedium(&stgmed);
				}
				
				pDataObject->Release();
				
				
}

void IDA_OnPrint(CDC *pDC, CPrintInfo* pInfo)
{
	
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
}

void IDA_OnEndPrinting(CDC *pDC, CPrintInfo* pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
    
}


extern "C" __declspec(dllexport)
void __cdecl IDA_Print() 
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
    CDC dc;
	DOCINFO di; 
	BOOL bPrintingOK;
	CPrintInfo Info;
	UINT page;
    CPrintDialog printDlg(FALSE);
	
    if (printDlg.DoModal() == IDCANCEL) {    
		
		return;
	}
	
    dc.Attach(printDlg.GetPrinterDC());     
    dc.m_bPrinting = TRUE;
	
	
	
	
    ::ZeroMemory (&di, sizeof (DOCINFO));
    di.cbSize = sizeof (DOCINFO);
    di.lpszDocName = "IDAView";
	
	bPrintingOK = dc.StartDoc(&di);    
	
	
	
    Info.m_rectDraw.SetRect(0,0, 
		dc.GetDeviceCaps(HORZRES), 
		dc.GetDeviceCaps(VERTRES));
	
    IDA_OnBeginPrinting(&dc, &Info);             
	//do i really want more than 1 page ?  ;)
  //  for ( page = Info.GetMinPage(); page <= Info.GetMaxPage() && bPrintingOK; page++)
    //{
        dc.StartPage();                     
      //  Info.m_nCurPage = page;
        IDA_OnPrint(&dc, &Info);               
      //  bPrintingOK = (dc.EndPage() > 0);   
    //}
    IDA_OnEndPrinting(&dc, &Info);             
	
    //if (bPrintingOK)
        dc.EndDoc();                       
   // else
     //   dc.AbortDoc();                     
	
    dc.DeleteDC();                         
}

/////////////////////////////////////////////////////////////////////////////
// CIDAPrintApp

BEGIN_MESSAGE_MAP(CIDAPrintApp, CWinApp)
//{{AFX_MSG_MAP(CIDAPrintApp)
// NOTE - the ClassWizard will add and remove mapping macros here.
//    DO NOT EDIT what you see in these blocks of generated code!
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIDAPrintApp construction

CIDAPrintApp::CIDAPrintApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	
	CoInitialize(NULL);
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CIDAPrintApp object

CIDAPrintApp theApp;
