/*
IDA  PrintIt!  Plugin plugin
Copyright (C) 2006 Joseph  Moti  <xbxice@yahoo.com>
t

*/
#include <windows.h>
#include <ida.hpp>
#include <idp.hpp>
#include <loader.hpp>

typedef void (__cdecl *LPFN_PRINTIT)(void);


char   IDAP_comment[] 	= "IDA Print  plugin";
char   IDAP_help[]    	= "Print plugin";
char   IDAP_name[]    	= "Print it ! ";
char   IDAP_hotkey[]   	= "Alt-J";






WNDPROC                  g_pOrigIDAViewWndProc=NULL;
HWND                     g_hIDAViewA;
HWND                     g_hIDAViewAParent;
LONG                     g_IDAViewStyle,g_IDAViewExStyle;
HMODULE                  g_hIDAPrintModule;
LPFN_PRINTIT             g_pfnPrintIt;

DWORD WINAPI             IDAThreadProc(LPVOID);


LRESULT APIENTRY  IDAViewbClassProc(
									   HWND , 
									   UINT , 
									   WPARAM , 
									   LPARAM );


BOOL CALLBACK EnumIDAChildProc(   HWND hwnd,
							   LPARAM lParam
							   )
{
	
	
	
	char cWndTitle[0x100];
	GetWindowText(hwnd,cWndTitle,sizeof(cWndTitle));
	
	if(strncmp(cWndTitle,"IDA View-A",10)==0){
	
		g_hIDAViewA=hwnd;
		
		return FALSE;
		
		
	}
	
	return TRUE;
}




int IDAP_init(void)
{

    msg("Copyright (C) 2006,Jospeh Moti\n");

	char cModulePath[MAX_PATH];
	GetModuleFileName(GetModuleHandle("PrintIt.plw"),cModulePath,sizeof(cModulePath));
	char *p=strstr(cModulePath,"plugins\\");

	if  (!p){
		msg("unable to locate  IDA plugins  folder.\n");
		return PLUGIN_SKIP;
	}
	p=strchr(p,'\\')+1;
	memcpy(p,"IDAPrint.dll",13);

	g_hIDAPrintModule=GetModuleHandle(cModulePath);
	if (g_hIDAPrintModule==NULL){
		g_hIDAPrintModule=LoadLibrary(cModulePath);
		if (!g_hIDAPrintModule){
			
			
			msg("Failed loading IDAPrint.dll\n");
			return PLUGIN_SKIP;
			
		}
	}
	g_pfnPrintIt=(LPFN_PRINTIT)GetProcAddress(g_hIDAPrintModule,"IDA_Print");
	msg("loading of IDAPrint plugin success.\n");
	return PLUGIN_KEEP;
}




void IDAP_term(void)
{

	FreeLibrary(g_hIDAPrintModule);
	return;
}





BOOL SubClassIDAViewWnd(HWND hWnd)
{
	


	if (g_pOrigIDAViewWndProc==NULL){
	
		g_pOrigIDAViewWndProc=(WNDPROC)SetWindowLong (hWnd,GWL_WNDPROC,
			                                 (LONG)IDAViewbClassProc);
	
		return TRUE;
		
	}
	return TRUE;
	
	
}

WORD WINAPI IDASend2PrinterThreadProc(
						   LPVOID lpParameter   
						   )


{

	(*g_pfnPrintIt)();

	return 0;
}

LRESULT APIENTRY  IDAViewbClassProc(
									HWND hwnd, 
									UINT uMsg, 
									WPARAM wParam, 
									LPARAM lParam) 
{ 
	
	
	
	
	switch(uMsg)
	{
		
	case WM_KEYDOWN:
		
		switch (wParam) 
        { 
			
			
			
		case  '1':
			{
				
				
				
			
				if ( GetKeyState(VK_CONTROL) < 0  )   {
					if (GetWindowLong(g_hIDAViewA,GWL_STYLE)==0x94CF0044){

					char form[]="Give name to snapshot \n<:A:80:80::>\n";
					char  result[MAXSTR]={0};
					if (!AskUsingForm_c(form,result))  break;

					SetWindowText(g_hIDAViewA,result);

					
					

					
					keybd_event (VK_SNAPSHOT, 1, 0, 0);
					
				
					//SetWindowText(g_hIDAViewA,"IDA View-A Press"
					//	  "[Ctrl+1=snapshot] [Ctrl+2=send2printer] [Ctrl+3=restore/switch]");

					
					msg("Take  snapshot...\n");
					}
					
					
					
					
				}
				
				break;
			}
			break;
			
		case  '2':
			{
				
				if ( GetKeyState(VK_CONTROL) < 0  )   {
					if (GetWindowLong(g_hIDAViewA,GWL_STYLE)==0x94CF0044){
					msg("Sending to Printer....\n");
					DWORD  dwThreadID;
					
					CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)IDASend2PrinterThreadProc,
						0,0,&dwThreadID);
					}
				//	(*g_pfnPrintIt)();
				}
				
				
				break;
			}
		case  '3':
			{
				
				
				
				
				if ( GetKeyState(VK_CONTROL) < 0  )   {
					if (GetWindowLong(g_hIDAViewA,GWL_STYLE)!=0x94CF0044){
						
						DWORD  dwThreadID;
						
						CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)IDAThreadProc,
							0,0,&dwThreadID);
						
					}else{
						SetWindowText(g_hIDAViewA,"IDA View-A");

						SetWindowLong(g_hIDAViewA,GWL_STYLE,g_IDAViewStyle);
						SetWindowLong(g_hIDAViewA,GWL_EXSTYLE,g_IDAViewExStyle);
						SetParent(g_hIDAViewA,g_hIDAViewAParent);
					}
				}
				
				break;
			}
			
			break;
		}
		
		
		default:
			break;
	}
	
	
	
	return CallWindowProc(g_pOrigIDAViewWndProc, hwnd, uMsg, wParam,lParam);
	
	
	
} 





DWORD WINAPI IDAThreadProc(
						   LPVOID lpParameter   
						   )
						   
						   
{
	
	
	EnumChildWindows(FindWindow("TIdaWindow",NULL),
		(WNDENUMPROC )EnumIDAChildProc,0);
	
	if(g_hIDAViewA==NULL){

		msg ("seems like IDA main wnd class name !=TIdaWindow");
		return -1;
	}
	g_hIDAViewAParent=GetParent(g_hIDAViewA);
	
	SetWindowText(g_hIDAViewA,"IDA View-A Press [Ctrl+1=snapshot] [Ctrl+2=send2printer] [Ctrl+3=restore/switch]");
	
	
	g_IDAViewStyle=GetWindowLong(g_hIDAViewA,GWL_STYLE);
	g_IDAViewExStyle=GetWindowLong(g_hIDAViewA,GWL_EXSTYLE);
	SetWindowLong(g_hIDAViewA,GWL_STYLE,0x94CF0044);
	SetWindowLong(g_hIDAViewA,GWL_EXSTYLE,0x00010100);
	
	SetParent(g_hIDAViewA,NULL);
	SubClassIDAViewWnd(FindWindowEx(g_hIDAViewA,0,"IDAView",0));
	SetWindowPos(g_hIDAViewA, 0,15, 15, -1, -1,
        SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	BringWindowToTop(g_hIDAViewA);
	
	
	
	
	return 0;
}

void IDAP_run(int arg)
{
	
	

	DWORD  dwThreadID;

	CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)IDAThreadProc,
		0,0,&dwThreadID);
	
	return;
}





plugin_t PLUGIN =
{
	IDP_INTERFACE_VERSION,
	0,		
	IDAP_init,
	IDAP_term,	
	IDAP_run,	
	IDAP_comment,	
	IDAP_help,
	IDAP_name,	
		
	IDAP_hotkey	
};
